/*
 *  This file is part of uIRCd. (https://git.redxen.eu/caskd/uIRCd)
 *  Copyright (c) 2019, 2020 Alex-David Denes
 *
 *  uIRCd is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *  uIRCd is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with uIRCd.  If not, see <https://www.gnu.org/licenses/>.
 */

#include "buffer.h"

ssize_t
get_buffer_line(char* buf)
{
	if (buf == NULL) return -1;
	char* ppoi;
	if ((ppoi = strchr(buf, '\n')) != NULL) {
		*ppoi = '\0';
		if (ppoi > buf && *(ppoi - 1) == '\r') *(ppoi - 1) = '\0';
		return ++ppoi - buf;
	}
	return 0;
}

ssize_t
flush_buffer(char* buf, size_t buflen, int fd)
{
	ssize_t res;
	char*   pos = buf;
	LOG(LOG_DEBUG, "Will write %s to socket %i", buf, fd);
	for (;;) {
		if ((size_t)(res = write(fd, pos, buflen - (size_t)(pos - buf))) != buflen - (size_t)(pos - buf)) {
			if (res == -1 && errno != EINTR) return -1;
			else
				pos += res;
		} else
			return res;
	}
}

