/*
 *  This file is part of uIRCd. (https://git.redxen.eu/caskd/uIRCd)
 *  Copyright (c) 2019, 2020 Alex-David Denes
 *
 *  uIRCd is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *  uIRCd is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with uIRCd.  If not, see <https://www.gnu.org/licenses/>.
 */

#include "connection.h"
#include "limits.h"
#include "logging.h"

#include <ctype.h>     // isalpha() isdigit()
#include <errno.h>     // errno
#include <fcntl.h>     // fnctl()
#include <limits.h>    // ??
#include <stdbool.h>   // bool
#include <stdio.h>     // fopen() FILE fprintf()
#include <string.h>    // strerror()
#include <sys/stat.h>  // mkfifo() mkdir()
#include <sys/types.h> // size_t ssize_t mode_t

#ifndef UIRCD_GUARD_FILESYSTEM
#define UIRCD_GUARD_FILESYSTEM

int     mkdir_bottomup(char* path);
int     makeinput(const char* path);
bool    write_log(const char* path, const char* message);
bool    cleanup_path_names(char* name);
bool    add_socket_flags(int fd, int flags);
ssize_t get_path(char* buf, size_t lim, Connection* conn, IRC_Message* msg, bool global, bool input, bool output);
void    clean_and_push(size_t* lim, size_t res, char** buf, bool dir);

#endif /* UIRCD_GUARD_FILESYSTEM */

