/*
 *  This file is part of uIRCd. (https://git.redxen.eu/caskd/uIRCd)
 *  Copyright (c) 2019, 2020 Alex-David Denes
 *
 *  uIRCd is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *  uIRCd is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with uIRCd.  If not, see <https://www.gnu.org/licenses/>.
 */

#include "logging.h"

#include <errno.h>   // errno
#include <signal.h>  // sig_atomic_t
#include <stdbool.h> // true, false
#include <stdio.h>   // NULL
#include <string.h>  // strerror()

#ifndef UIRCD_GUARD_SIGNAL
#define UIRCD_GUARD_SIGNAL

/* Description:
 * This allows signals to be caught and for them to change something in the stack without causing problems or undefined behaviour */
extern sig_atomic_t volatile run;

void stop_loop(int sig, siginfo_t* info, void* ucontext);
int  setup_signals(void);

#endif /* UIRCD_GUARD_SIGNAL */

